From 7b3e05ab744527d2f2717d50f7a7c34fbc8ee1fa Mon Sep 17 00:00:00 2001
From: Christophe Siraut <csiraut@entrouvert.com>
Date: Fri, 15 Feb 2019 16:59:17 +0100
Subject: [PATCH] add Lato font (#30737)

---
 README                                      |   7 +++++-
 static/fonts/Lato/Lato-Black.woff           | Bin 0 -> 297272 bytes
 static/fonts/Lato/Lato-Black.woff2          | Bin 0 -> 176748 bytes
 static/fonts/Lato/Lato-BlackItalic.woff     | Bin 0 -> 310776 bytes
 static/fonts/Lato/Lato-BlackItalic.woff2    | Bin 0 -> 185544 bytes
 static/fonts/Lato/Lato-Bold.woff            | Bin 0 -> 309728 bytes
 static/fonts/Lato/Lato-Bold.woff2           | Bin 0 -> 184912 bytes
 static/fonts/Lato/Lato-BoldItalic.woff      | Bin 0 -> 323344 bytes
 static/fonts/Lato/Lato-BoldItalic.woff2     | Bin 0 -> 193308 bytes
 static/fonts/Lato/Lato-Hairline.woff        | Bin 0 -> 274692 bytes
 static/fonts/Lato/Lato-Hairline.woff2       | Bin 0 -> 161672 bytes
 static/fonts/Lato/Lato-HairlineItalic.woff  | Bin 0 -> 293900 bytes
 static/fonts/Lato/Lato-HairlineItalic.woff2 | Bin 0 -> 173948 bytes
 static/fonts/Lato/Lato-Heavy.woff           | Bin 0 -> 309924 bytes
 static/fonts/Lato/Lato-Heavy.woff2          | Bin 0 -> 184520 bytes
 static/fonts/Lato/Lato-HeavyItalic.woff     | Bin 0 -> 322780 bytes
 static/fonts/Lato/Lato-HeavyItalic.woff2    | Bin 0 -> 194272 bytes
 static/fonts/Lato/Lato-Light.woff           | Bin 0 -> 310884 bytes
 static/fonts/Lato/Lato-Light.woff2          | Bin 0 -> 181500 bytes
 static/fonts/Lato/Lato-LightItalic.woff     | Bin 0 -> 325296 bytes
 static/fonts/Lato/Lato-LightItalic.woff2    | Bin 0 -> 192916 bytes
 static/fonts/Lato/Lato-Medium.woff          | Bin 0 -> 305920 bytes
 static/fonts/Lato/Lato-Medium.woff2         | Bin 0 -> 182144 bytes
 static/fonts/Lato/Lato-MediumItalic.woff    | Bin 0 -> 325936 bytes
 static/fonts/Lato/Lato-MediumItalic.woff2   | Bin 0 -> 194608 bytes
 static/fonts/Lato/Lato-Regular.woff         | Bin 0 -> 309192 bytes
 static/fonts/Lato/Lato-Regular.woff2        | Bin 0 -> 182708 bytes
 static/fonts/Lato/Lato-RegularItalic.woff   | Bin 0 -> 328412 bytes
 static/fonts/Lato/Lato-RegularItalic.woff2  | Bin 0 -> 195704 bytes
 static/fonts/Lato/Lato-Semibold.woff        | Bin 0 -> 312952 bytes
 static/fonts/Lato/Lato-Semibold.woff2       | Bin 0 -> 184076 bytes
 static/fonts/Lato/Lato-SemiboldItalic.woff  | Bin 0 -> 327188 bytes
 static/fonts/Lato/Lato-SemiboldItalic.woff2 | Bin 0 -> 195128 bytes
 static/fonts/Lato/Lato-Thin.woff            | Bin 0 -> 306060 bytes
 static/fonts/Lato/Lato-Thin.woff2           | Bin 0 -> 180576 bytes
 static/fonts/Lato/Lato-ThinItalic.woff      | Bin 0 -> 323532 bytes
 static/fonts/Lato/Lato-ThinItalic.woff2     | Bin 0 -> 191804 bytes
 static/includes/_font-lato.scss             |  26 ++++++++++++++++++++
 38 files changed, 32 insertions(+), 1 deletion(-)
 create mode 100644 static/fonts/Lato/Lato-Black.woff
 create mode 100644 static/fonts/Lato/Lato-Black.woff2
 create mode 100644 static/fonts/Lato/Lato-BlackItalic.woff
 create mode 100644 static/fonts/Lato/Lato-BlackItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Bold.woff
 create mode 100644 static/fonts/Lato/Lato-Bold.woff2
 create mode 100644 static/fonts/Lato/Lato-BoldItalic.woff
 create mode 100644 static/fonts/Lato/Lato-BoldItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Hairline.woff
 create mode 100644 static/fonts/Lato/Lato-Hairline.woff2
 create mode 100644 static/fonts/Lato/Lato-HairlineItalic.woff
 create mode 100644 static/fonts/Lato/Lato-HairlineItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Heavy.woff
 create mode 100644 static/fonts/Lato/Lato-Heavy.woff2
 create mode 100644 static/fonts/Lato/Lato-HeavyItalic.woff
 create mode 100644 static/fonts/Lato/Lato-HeavyItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Light.woff
 create mode 100644 static/fonts/Lato/Lato-Light.woff2
 create mode 100644 static/fonts/Lato/Lato-LightItalic.woff
 create mode 100644 static/fonts/Lato/Lato-LightItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Medium.woff
 create mode 100644 static/fonts/Lato/Lato-Medium.woff2
 create mode 100644 static/fonts/Lato/Lato-MediumItalic.woff
 create mode 100644 static/fonts/Lato/Lato-MediumItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Regular.woff
 create mode 100644 static/fonts/Lato/Lato-Regular.woff2
 create mode 100644 static/fonts/Lato/Lato-RegularItalic.woff
 create mode 100644 static/fonts/Lato/Lato-RegularItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Semibold.woff
 create mode 100644 static/fonts/Lato/Lato-Semibold.woff2
 create mode 100644 static/fonts/Lato/Lato-SemiboldItalic.woff
 create mode 100644 static/fonts/Lato/Lato-SemiboldItalic.woff2
 create mode 100644 static/fonts/Lato/Lato-Thin.woff
 create mode 100644 static/fonts/Lato/Lato-Thin.woff2
 create mode 100644 static/fonts/Lato/Lato-ThinItalic.woff
 create mode 100644 static/fonts/Lato/Lato-ThinItalic.woff2
 create mode 100644 static/includes/_font-lato.scss

diff --git a/README b/README
index 824ebe37..bbd8c984 100644
--- a/README
+++ b/README
@@ -141,7 +141,12 @@ copyright notices:
   #
   # https://www.fontsquirrel.com/license/roboto-slab
 
-~~~~
+* Lato font
+  # Copyright (c) 2014, Typoland
+  #
+  # This Font Software is licensed under the SIL Open Font License, Version 1.1.
+  #
+  # http://www.latofonts.com/
 
 Some theme variant files have their own specific licenses; refer to
 static/$theme/README for details.
diff --git a/static/fonts/Lato/Lato-Black.woff b/static/fonts/Lato/Lato-Black.woff
new file mode 100644
index 0000000000000000000000000000000000000000..a0ab25e9afc5300e204cfff09f30dfc498bc9dba
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Black.woff2 b/static/fonts/Lato/Lato-Black.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3ee7cd441e47372f956e43128696e300208eca9f
GIT binary patch
diff --git a/static/fonts/Lato/Lato-BlackItalic.woff b/static/fonts/Lato/Lato-BlackItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..30f2c71ca39e0ff51f3faf5573fb8a9be1d37c0b
GIT binary patch
diff --git a/static/fonts/Lato/Lato-BlackItalic.woff2 b/static/fonts/Lato/Lato-BlackItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..6a59bdbef51d850d3540054d6150d346b09a3d3d
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Bold.woff b/static/fonts/Lato/Lato-Bold.woff
new file mode 100644
index 0000000000000000000000000000000000000000..c6dff51f063cc732fdb5fe786a8966de85f4ebec
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Bold.woff2 b/static/fonts/Lato/Lato-Bold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..bb195043cfc07fa52741c6144d7378b5ba8be4c5
GIT binary patch
diff --git a/static/fonts/Lato/Lato-BoldItalic.woff b/static/fonts/Lato/Lato-BoldItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..88ad05b9ff413055b4d4e89dd3eec1c193fa20c6
GIT binary patch
diff --git a/static/fonts/Lato/Lato-BoldItalic.woff2 b/static/fonts/Lato/Lato-BoldItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..c4e3d804b57b625b16a36d767bfca6bbf63d414e
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Hairline.woff b/static/fonts/Lato/Lato-Hairline.woff
new file mode 100644
index 0000000000000000000000000000000000000000..2297f4369c2a1eb5556d375764c5199a925baf47
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Hairline.woff2 b/static/fonts/Lato/Lato-Hairline.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..34ca2fad2618dd2ad331aabf88f1753620e104a5
GIT binary patch
diff --git a/static/fonts/Lato/Lato-HairlineItalic.woff b/static/fonts/Lato/Lato-HairlineItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..7ac0a1465694c0d46ae6c65d44cd71f32254ab6b
GIT binary patch
diff --git a/static/fonts/Lato/Lato-HairlineItalic.woff2 b/static/fonts/Lato/Lato-HairlineItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..b5fceba0dd1c05ecbc04243f7a11b796d754c68b
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Heavy.woff b/static/fonts/Lato/Lato-Heavy.woff
new file mode 100644
index 0000000000000000000000000000000000000000..43a3c80fbac8d2f6072698bb6ad5110fb9a411c1
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Heavy.woff2 b/static/fonts/Lato/Lato-Heavy.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..8a2436573b7f46c306b1f35536754dbbd33afc66
GIT binary patch
diff --git a/static/fonts/Lato/Lato-HeavyItalic.woff b/static/fonts/Lato/Lato-HeavyItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..dbac8a9f0c305a0051cac442bf28ea94b7e64932
GIT binary patch
diff --git a/static/fonts/Lato/Lato-HeavyItalic.woff2 b/static/fonts/Lato/Lato-HeavyItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..61989ae09a991fc4fcfecb00835ee2b8318a8801
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Light.woff b/static/fonts/Lato/Lato-Light.woff
new file mode 100644
index 0000000000000000000000000000000000000000..77b4e148f7f48e9b2df6bdbe6d082c8ab8244eb8
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Light.woff2 b/static/fonts/Lato/Lato-Light.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..ce49f82217ea5a4820e828eeabf3e3c714864758
GIT binary patch
diff --git a/static/fonts/Lato/Lato-LightItalic.woff b/static/fonts/Lato/Lato-LightItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..da3dfa30a456ca0a5971e7b6661082697dd55c7a
GIT binary patch
diff --git a/static/fonts/Lato/Lato-LightItalic.woff2 b/static/fonts/Lato/Lato-LightItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..0c897ce40ca1dc8c905f0404466138f69d6ba86d
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Medium.woff b/static/fonts/Lato/Lato-Medium.woff
new file mode 100644
index 0000000000000000000000000000000000000000..39d53fdeacb5f43e1db44c5af0f3211840684fb6
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Medium.woff2 b/static/fonts/Lato/Lato-Medium.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..01792cbd13451c1ac83300a7fd30e82dd897e80b
GIT binary patch
diff --git a/static/fonts/Lato/Lato-MediumItalic.woff b/static/fonts/Lato/Lato-MediumItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..724962beee28dd7b828eddc501809718704f69f0
GIT binary patch
diff --git a/static/fonts/Lato/Lato-MediumItalic.woff2 b/static/fonts/Lato/Lato-MediumItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..1cc79653a631b76013c15b7304cb5ec75204eabc
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Regular.woff b/static/fonts/Lato/Lato-Regular.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ae1307ff5f4c48678621c240f8972d5a6e20b22c
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Regular.woff2 b/static/fonts/Lato/Lato-Regular.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3bf9843328a6359b6bd06e50010319c63da0d717
GIT binary patch
diff --git a/static/fonts/Lato/Lato-RegularItalic.woff b/static/fonts/Lato/Lato-RegularItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..76114bc03362242c3325ecda6ce6d02bb737880f
GIT binary patch
diff --git a/static/fonts/Lato/Lato-RegularItalic.woff2 b/static/fonts/Lato/Lato-RegularItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..3404f37e2e312757841abe20343588a7740768ca
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Semibold.woff b/static/fonts/Lato/Lato-Semibold.woff
new file mode 100644
index 0000000000000000000000000000000000000000..794417f6af35de21abc0bb8748e7ae969e2dfe3a
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Semibold.woff2 b/static/fonts/Lato/Lato-Semibold.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..5916925412420a12f766e921f01a1ba075aab5b2
GIT binary patch
diff --git a/static/fonts/Lato/Lato-SemiboldItalic.woff b/static/fonts/Lato/Lato-SemiboldItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..d1df7676e867c245731b6edb000e3f0784f803c9
GIT binary patch
diff --git a/static/fonts/Lato/Lato-SemiboldItalic.woff2 b/static/fonts/Lato/Lato-SemiboldItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..5e6ac271926780eb6e643524c597f7a539834789
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Thin.woff b/static/fonts/Lato/Lato-Thin.woff
new file mode 100644
index 0000000000000000000000000000000000000000..760b12479c59e5bd7a2096512ab5146012066740
GIT binary patch
diff --git a/static/fonts/Lato/Lato-Thin.woff2 b/static/fonts/Lato/Lato-Thin.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..2c4f52f2bb8152680d68ca6c15997bb34c327f71
GIT binary patch
diff --git a/static/fonts/Lato/Lato-ThinItalic.woff b/static/fonts/Lato/Lato-ThinItalic.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ef8de9a0dacbaa813f46ba0ce6ead24b62042641
GIT binary patch
diff --git a/static/fonts/Lato/Lato-ThinItalic.woff2 b/static/fonts/Lato/Lato-ThinItalic.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..e15214fdf9f885efdb0c308a4879734f28eb4054
GIT binary patch
diff --git a/static/includes/_font-lato.scss b/static/includes/_font-lato.scss
new file mode 100644
index 00000000..77249df5
--- /dev/null
+++ b/static/includes/_font-lato.scss
@@ -0,0 +1,26 @@
+$lato-font-path: '../fonts/Lato' !default;
+
+@mixin lato-font($type, $weight, $style: normal) {
+	@font-face {
+		font-family: 'Lato';
+		src: url('#{$lato-font-path}/Lato-#{$type}.woff2') format('woff2'),
+		     url('#{$lato-font-path}/Lato-#{$type}.woff') format('woff');
+		font-weight: $weight;
+		font-style: $style;
+	}
+}
+
+@mixin lato-font-pair($type, $weight) {
+	@include lato-font($type, $weight);
+	@include lato-font(#{$type}Italic, $weight, italic);
+}
+
+@include lato-font-pair('Hairline', 100);
+@include lato-font-pair('Thin', 200);
+@include lato-font-pair('Light', 300);
+@include lato-font-pair('Regular', 400);
+@include lato-font-pair('Medium', 500);
+@include lato-font-pair('Semibold', 600);
+@include lato-font-pair('Bold', 700);
+@include lato-font-pair('Heavy', 800);
+@include lato-font-pair('Black', 900);
-- 
2.20.1