From 52d847a066599a339c1c7270dbcd19add0c42b3b Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Tue, 26 Mar 2019 20:33:40 +0100
Subject: [PATCH 2/7] bouches-du-rhone: add proper padding instead of abusing
 textcell class (#31744)

---
 static/bouches-du-rhone/_custom.scss            | 17 +++++++++++++++++
 .../combo/json/cd13_dossier_contacts.html       |  2 --
 .../combo/json/cd13_dossier_coordonnees.html    |  2 --
 .../combo/json/cd13_dossier_demandes.html       |  2 --
 .../combo/json/cd13_dossier_entete.html         |  2 --
 .../combo/json/cd13_dossier_nom.html            |  2 --
 .../combo/json/cd13_liste_des_dossiers.html     |  2 --
 7 files changed, 17 insertions(+), 12 deletions(-)

diff --git a/static/bouches-du-rhone/_custom.scss b/static/bouches-du-rhone/_custom.scss
index 498c958e..a9aeb383 100644
--- a/static/bouches-du-rhone/_custom.scss
+++ b/static/bouches-du-rhone/_custom.scss
@@ -83,3 +83,20 @@ div#footer-wrapper {
 		}
 	}
 }
+
+div.cd13_dossier_nom,
+div.cd13_dossier_coordonnees,
+div.cd13_dossier_entete,
+div.cd13_dossier_demandes,
+div.cd13_dossier_contacts {
+	& > div > div.loading {
+		padding: 0;
+	}
+
+	& > div > div {
+		padding: 1rem;
+		h3:first-child {
+			margin-top: 0;
+		}
+	}
+}
diff --git a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_contacts.html b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_contacts.html
index e1395346..f0039f52 100644
--- a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_contacts.html
+++ b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_contacts.html
@@ -1,7 +1,6 @@
 {% load combo %}
 
 {% if json.data.dossier %}
-<div class="textcell" style="padding: 1rem;">
 <div class="dataview" style="display: block;">
 
   {% if json.data.dossier.beneficiaire.entourage %}
@@ -70,5 +69,4 @@
 Vous n'avez aucun contact d'indiqué.
   {% endif %}
 </div>
-</div>
 {% endif %}
diff --git a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_coordonnees.html b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_coordonnees.html
index c14e7c6a..1783ed27 100644
--- a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_coordonnees.html
+++ b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_coordonnees.html
@@ -2,7 +2,6 @@
 
 {% if json.data.dossier %}
 
-<div class="textcell" style="padding: 1rem;">
 <div class="dataview" style="display: block;">
 <h3>Coordonnées</h3>
   {% if json.data.dossier.beneficiaire.email %}
@@ -30,6 +29,5 @@
   </div>
   {% endif %}
 </div>
-</div>
 
 {% endif %}
diff --git a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_demandes.html b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_demandes.html
index 319416d8..e1c6f12b 100644
--- a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_demandes.html
+++ b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_demandes.html
@@ -1,7 +1,6 @@
 {% load combo %}
 {% if json.data.dossier %}
 
-<div class="textcell" style="padding: 1rem;">
 <div class="dataview" style="display: block;">
 {% if  json.data.dossier.demandes %}
 <h3 > Demandes</h3>
@@ -70,5 +69,4 @@ Vous n'avez aucune demande dans votre historique.
 </p>
 {% endif %}
 </div>
-</div>
 {% endif %}
diff --git a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_entete.html b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_entete.html
index 46605e7e..18fcab43 100644
--- a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_entete.html
+++ b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_entete.html
@@ -6,7 +6,6 @@
 
 {% if json.data.dossier %}
 
-<div class="textcell" style="padding: 1rem;">
 <div class="dataview" style="display: block;">
    <div class="field">
     <span class="label">Numéro de dossier</span>
@@ -25,7 +24,6 @@
   </div>
   {% endif %}
 </div>
-</div>
 {% else %}
 <p>Aucune information trouvée.</p>
 {% endif %}
diff --git a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_nom.html b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_nom.html
index 62bc4ab9..fda2bea2 100644
--- a/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_nom.html
+++ b/templates/variants/bouches-du-rhone/combo/json/cd13_dossier_nom.html
@@ -5,9 +5,7 @@
 {% else %}
 
 {% if json.data.dossier %}
-<div class="textcell" style="padding: 1rem;">
 <h2>{{json.data.dossier.beneficiaire.nom}} {{json.data.dossier.beneficiaire.prenom}}</h2>
-</div>
 {% else %}
 <p>Aucune information trouvée.</p>
 {% endif %}
diff --git a/templates/variants/bouches-du-rhone/combo/json/cd13_liste_des_dossiers.html b/templates/variants/bouches-du-rhone/combo/json/cd13_liste_des_dossiers.html
index c49ce422..1aa016f3 100644
--- a/templates/variants/bouches-du-rhone/combo/json/cd13_liste_des_dossiers.html
+++ b/templates/variants/bouches-du-rhone/combo/json/cd13_liste_des_dossiers.html
@@ -1,6 +1,5 @@
 {% load combo %}
 
-<div class="cell textcell">
 <h2 style="text-align: center;">Mes dossiers</h2>
 
 {% if json.data %}
@@ -73,4 +72,3 @@
 <p style="text-align: center;">Vous n'avez aucun dossier de bénéficiaire associé à votre compte.</p>
 
 {% endif %}<!-- json.data -->
-</div>
-- 
2.20.1